## indilib-2.1.6a.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)
PROJECT(libindi C CXX)
if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.31)
    cmake_policy(SET CMP0177 NEW)
endif()

# As moc files are generated in the binary dir, tell CMake
# to always look for includes there:
set(CMAKE_INCLUDE_CURRENT_DIR ON)

LIST(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake_modules/")
LIST(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../cmake_modules/")
include(GNUInstallDirs)
include(FeatureSummary)
include(CTest)

if(ANDROID OR "${CMAKE_SYSTEM_NAME}" STREQUAL "Android")
    set(ANDROID ON)
    add_definitions(-DANDROID)
endif()

include(CMakeCommon)
include(CheckSymbolExists)

# Clang Format support
if(UNIX OR APPLE)
    set(FORMAT_CODE OFF CACHE BOOL "Enable Clang Format")

    if(FORMAT_CODE MATCHES ON)
        FILE(GLOB_RECURSE ALL_SOURCE_FILES *.c *.cpp *.h)

        FOREACH(SOURCE_FILE ${ALL_SOURCE_FILES})
            STRING(FIND ${SOURCE_FILE} ${CMAKE_SOURCE_DIR} DIR_FOUND)

            if(NOT ${DIR_FOUND} EQUAL 0)
                LIST(REMOVE_ITEM ALL_SOURCE_FILES ${SOURCE_FILE})
            endif()
        ENDFOREACH()

        FIND_PROGRAM(CLANGFORMAT_EXE NAMES clang-format-5.0)

        if(CLANGFORMAT_EXE)
            ADD_CUSTOM_TARGET(clang-format COMMAND ${CLANGFORMAT_EXE} -style=file -i ${ALL_SOURCE_FILES})
        endif()
    endif()
endif()

# ####################################  INDI version  ################################################
set(CMAKE_INDI_VERSION_MAJOR 2)
set(CMAKE_INDI_VERSION_MINOR 1)
set(CMAKE_INDI_VERSION_RELEASE 6)

set(INDI_SOVERSION ${CMAKE_INDI_VERSION_MAJOR})
set(CMAKE_INDI_VERSION_STRING "${CMAKE_INDI_VERSION_MAJOR}.${CMAKE_INDI_VERSION_MINOR}.${CMAKE_INDI_VERSION_RELEASE}")
set(INDI_VERSION ${CMAKE_INDI_VERSION_MAJOR}.${CMAKE_INDI_VERSION_MINOR}.${CMAKE_INDI_VERSION_RELEASE})

execute_process(
    COMMAND git describe --tags
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    OUTPUT_VARIABLE GIT_TAG
    OUTPUT_STRIP_TRAILING_WHITESPACE
    RESULT_VARIABLE GIT_TAG_RESULT
)

if(NOT ${GIT_TAG_RESULT} EQUAL 0)
    set(GIT_TAG "${CMAKE_INDI_VERSION_STRING}-tgz")
endif()

add_definitions(-DGIT_TAG_STRING=\"${GIT_TAG}\")

# #######################################  Paths  ###################################################
set(DATA_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/share/indi/")
set(BIN_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/bin")
set(INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include")

if(APPLE)
    set(CMAKE_SHARED_LINKER_FLAGS "-undefined dynamic_lookup")
endif(APPLE)

# #################################  Install Directories  ###########################################
# # the following are directories where stuff will be installed to
set(INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include/")
set(PKGCONFIG_INSTALL_PREFIX "${CMAKE_INSTALL_LIBDIR}/pkgconfig/")
set(UDEVRULES_INSTALL_DIR "/lib/udev/rules.d" CACHE STRING "Base directory for udev rules")

set(PKG_CONFIG_LIBDIR ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR})

# ####################################  Build Options  ##############################################
# Select which components to build and what options to apply
OPTION(INDI_BUILD_SERVER "Build INDI Server" ON)
OPTION(INDI_BUILD_DRIVERS "Build INDI Drivers, Tools, and Examples" ON)
OPTION(INDI_BUILD_CLIENT "Build INDI POSIX Client" ON)
OPTION(INDI_BUILD_QT5_CLIENT "Build INDI Qt5 Client" OFF)
OPTION(INDI_BUILD_UNITTESTS "Build INDI tests" OFF)
OPTION(INDI_BUILD_INTEGTESTS "Build INDI integration tests" OFF)
OPTION(INDI_FAST_BLOB "Build INDI with Fast BLOB support" ON)
OPTION(INDI_BUILD_SHARED "Build shared library" ON)
OPTION(INDI_BUILD_STATIC "Build static library" ON)
OPTION(INDI_BUILD_XISF "Build XISF support" ON)
OPTION(INDI_BUILD_EXAMPLES "Build INDI examples" ON)
OPTION(INDI_INSTALL_UDEV_RULES "Install INDI udev rules" ON)

# System provided or bundled libs
OPTION(INDI_SYSTEM_HTTPLIB "Use system provided httplib" OFF)
OPTION(INDI_SYSTEM_JSONLIB "Use system provided json library" OFF)

if(UNIX AND NOT APPLE)
    OPTION(INDI_SHARED_MEMORY "Build INDI with support for UNIX protocol with shared memory" ON)
else()
    OPTION(INDI_SHARED_MEMORY "Build INDI with support for UNIX protocol with shared memory (require shm specific settings)" OFF)
endif()

OPTION(INDI_CALCULATE_MINMAX "Calculate and store image minimum and maximum values in FITS header" OFF)

set(CMAKE_REQUIRED_DEFINITIONS -D_GNU_SOURCE)
check_symbol_exists(mremap sys/mman.h HAVE_MREMAP)

if(HAVE_MREMAP)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -DHAVE_MREMAP")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_MREMAP")
endif()

# ##################################################################################################
# ########################################  Fast Blob  #############################################
# ##################################################################################################
if(INDI_FAST_BLOB)
    # Append ENCLEN attribute to outgoing BLOB elements to enable fast parsing by clients
    add_definitions(-DWITH_ENCLEN)
endif(INDI_FAST_BLOB)

# ##################################################################################################
# ###################################  UNIX protocol / SHM  ########################################
# ##################################################################################################
if(INDI_SHARED_MEMORY)
    if(APPLE)
        message(WARNING "Shared memory protocol require specific shared memory settings")
    else()
        add_definitions(-DENABLE_INDI_SHARED_MEMORY)
    endif()
endif()

# ##################################################################################################
# #####################################  Calculate Min/Max #########################################
# ##################################################################################################
if(INDI_CALCULATE_MINMAX)
    # Calculate Min/Max values to store them in FITS header
    add_definitions(-DWITH_MINMAX)
endif(INDI_CALCULATE_MINMAX)

# ##################################################################################################
# ####################################  Components  ################################################
# ##################################################################################################
set_package_properties(Nova PROPERTIES DESCRIPTION "A general purpose, double precision, Celestial Mechanics, Astrometry and Astrodynamics library" URL "http://libnova.sourceforge.net" TYPE REQUIRED PURPOSE "Provides INDI with astrodynamics library.")
set_package_properties(CFITSIO PROPERTIES DESCRIPTION "A library for reading and writing data files in FITS (Flexible Image Transport System) data format" URL "http://heasarc.gsfc.nasa.gov/fitsio/fitsio.html" TYPE REQUIRED PURPOSE "Provides INDI with FITS I/O support.")

# ##################################################################################################
# #########  Put runtime files together in PE/COFF platforms to enable in-tree execution  ##########
# ##################################################################################################
if (WIN32 OR CYGWIN)
    if (NOT DEFINED CMAKE_RUNTIME_OUTPUT_DIRECTORY)
        set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/bin")
    endif ()
endif ()

# ##################################################################################################
# ####################################  Common Files  ##############################################
# ##################################################################################################
include_directories(libs)
install(FILES
    libs/indimacros.h
    DESTINATION
    ${INCLUDE_INSTALL_DIR}/libindi
    COMPONENT Devel
)

# ##################################################################################################
# ####################################  bundled libs  ##############################################
# ##################################################################################################
if(INDI_SYSTEM_HTTPLIB)
    find_package(httplib REQUIRED)
    include_directories(${HTTPLIB_INCLUDE_DIR})
    set(SYSTEM_HTTPLIB 1)
    message(STATUS "Using system provided httplib version ${HTTPLIB_VERSION}")
else()
    include_directories(${CMAKE_CURRENT_SOURCE_DIR}/libs/httplib)
    set(SYSTEM_HTTPLIB 0)
    message(STATUS "Using bundled httplib")
endif(INDI_SYSTEM_HTTPLIB)

if(INDI_SYSTEM_JSONLIB)
    find_package(nlohmann_json REQUIRED)
    set(SYSTEM_JSONLIB 1)
    set(JSONLIB nlohmann_json::nlohmann_json)
    add_definitions(-D_USE_SYSTEM_JSONLIB)
    message(STATUS "Using system provided Niels Lohmann's json library")
else(INDI_SYSTEM_JSONLIB)
    set(SYSTEM_JSONLIB 0)
    set(JSONLIB "")
    message(STATUS "Using bundled json library")
endif(INDI_SYSTEM_JSONLIB)

# ###################################################################################################
#
# Component   : INDI Core
# Dependencies:
# Supported OS: All
#
# ##################################################################################################
add_subdirectory(libs/indicore)

# ##################################################################################################
#
# Component   : indidevice
# Dependencies: indicore
# Supported OS: All
#
# ##################################################################################################
add_subdirectory(libs/indidevice)

# ##################################################################################################
#
# Component   : indiabstractclient
# Dependencies: indicore, indidevice
# Supported OS: All
#
# ##################################################################################################
if(INDI_BUILD_CLIENT OR INDI_BUILD_QT5_CLIENT)
    add_subdirectory(libs/indiabstractclient)
endif()

# ##################################################################################################
#
# Component   : INDI Server
# Dependencies: pthreads
# Supported OS: Linux, BSD, MacOS, Cygwin
#
# ##################################################################################################
if(INDI_BUILD_SERVER)
    add_subdirectory(indiserver)
endif()

# ##################################################################################################
#
# Component   : INDI Client
# Dependencies: zlib, cfitsio
# Supported OS: Linux, BSD, MacOS, Windows, Cygwin
# N.B. Windows support pending migration of networking code
#
# ##################################################################################################
if(INDI_BUILD_CLIENT AND NOT ANDROID)
    message(STATUS "Building INDI Client")
    add_subdirectory(libs/sockets)
    add_subdirectory(libs/indiclient)
endif(INDI_BUILD_CLIENT AND NOT ANDROID)

# ##################################################################################################
#
# Component   : INDI Qt5 Client
# Dependencies: Qt5Network, zlib, cfitsio, Qt5Core
# Supported OS: Linux, BSD, MacOS, Cygwin, Windows, Android
#
# ##################################################################################################
if(INDI_BUILD_QT5_CLIENT)
    message(STATUS "Building INDI Client with Qt5 support")
    add_subdirectory(libs/indiclientqt)
endif(INDI_BUILD_QT5_CLIENT)


# ##################################################################################################
#
# Component   : INDI Drivers, Tools, and Examples
# Dependencies: pthreads, usb1, zLib, cfitsio, nova, curl, jpeg (Linux Only)
# Supported OS: Linux, BSD, MacOS, Cygwin
# N.B. Webcam drivers only supported under Linux (Video4Linux2). Joystick support only under Linux
#
# ##################################################################################################
if(INDI_BUILD_DRIVERS)
    if(WIN32 OR ANDROID)
        message(WARNING "INDI drivers are only supported under Linux, BSD, MacOS, and Cygwin while current system is " ${CMAKE_SYSTEM_NAME})

=== examples/CMakeLists.txt ===
add_subdirectory(tutorial_one)
add_subdirectory(tutorial_two)
add_subdirectory(tutorial_three)
add_subdirectory(tutorial_four)
add_subdirectory(tutorial_five)
add_subdirectory(tutorial_six)
add_subdirectory(tutorial_seven)
add_subdirectory(tutorial_eight)

=== drivers/focuser/CMakeLists.txt ===
# ############### Focuser Simulator ################
SET(focussimulator_SRC
    focus_simulator.cpp)

add_executable(indi_simulator_focus ${focussimulator_SRC})
target_link_libraries(indi_simulator_focus indidriver)
install(TARGETS indi_simulator_focus RUNTIME DESTINATION bin)

# ############### Robo Focuser ################
SET(robofocus_SRC
    robofocus.cpp)

add_executable(indi_robo_focus ${robofocus_SRC})
target_link_libraries(indi_robo_focus indidriver)
install(TARGETS indi_robo_focus RUNTIME DESTINATION bin)

# ############### Robo Focuser ################
# ############### iEAF Focuser ################
SET(ieaffocus_SRC
    ieaffocus.cpp)

add_executable(indi_ieaf_focus ${ieaffocus_SRC})
target_link_libraries(indi_ieaf_focus indidriver)
install(TARGETS indi_ieaf_focus RUNTIME DESTINATION bin)


# ############### iEAF Focuser ################
SET(fcusb_SRC
    fcusb.cpp)

add_executable(indi_fcusb_focus ${fcusb_SRC})
target_link_libraries(indi_fcusb_focus indidriver)
install(TARGETS indi_fcusb_focus RUNTIME DESTINATION bin)

# ############### Rigelsys NFocus Focuser ################
SET(nfocus_SRC
    nfocus.cpp)

add_executable(indi_nfocus ${nfocus_SRC})
target_link_libraries(indi_nfocus indidriver)
install(TARGETS indi_nfocus RUNTIME DESTINATION bin)

# ############### Rigelsys NStep Focuser ################
SET(nstep_SRC
    nstep.cpp)

add_executable(indi_nstep_focus ${nstep_SRC})
target_link_libraries(indi_nstep_focus indidriver)
install(TARGETS indi_nstep_focus RUNTIME DESTINATION bin)

# ############### PlaneWave EFA ################
SET(efa_SRC
    planewave_efa.cpp)

add_executable(indi_efa_focus ${efa_SRC})
target_link_libraries(indi_efa_focus indidriver)
install(TARGETS indi_efa_focus RUNTIME DESTINATION bin)

# ############### Celestron SCT Focuser ################
SET(celestronsct_SRC
    celestronauxpacket.cpp
    celestron.cpp)

add_executable(indi_celestron_sct_focus ${celestronsct_SRC})
target_link_libraries(indi_celestron_sct_focus indidriver)
install(TARGETS indi_celestron_sct_focus RUNTIME DESTINATION bin)

# ############### AAF2 Focuser ################
SET(aaf2_SRC
    aaf2.cpp)

add_executable(indi_aaf2_focus ${aaf2_SRC})
target_link_libraries(indi_aaf2_focus indidriver)
install(TARGETS indi_aaf2_focus RUNTIME DESTINATION bin)

# ############### AAF2 Focuser ################
SET(rbfocus_SRC
    rbfocus.cpp)

add_executable(indi_rbfocus_focus ${rbfocus_SRC})
target_link_libraries(indi_rbfocus_focus indidriver)
install(TARGETS indi_rbfocus_focus RUNTIME DESTINATION bin)

# ############### Astromech Focuser ################
SET(astromech_focuser_SRC
    astromech_focuser.cpp)

add_executable(indi_astromechfoc ${astromech_focuser_SRC})
target_link_libraries(indi_astromechfoc indidriver)
install(TARGETS indi_astromechfoc RUNTIME DESTINATION bin)

# ############### Pinefeat CEF Focuser ################
SET(pinefeat_cef_SRC
    pinefeat_cef.cpp)

add_executable(indi_pinefeat_cef_focus ${pinefeat_cef_SRC})
target_link_libraries(indi_pinefeat_cef_focus indidriver)
install(TARGETS indi_pinefeat_cef_focus RUNTIME DESTINATION bin)

# ############### Moonlite Focuser ################
SET(moonlite_SRC
    moonlite.cpp)

add_executable(indi_moonlite_focus ${moonlite_SRC})
target_link_libraries(indi_moonlite_focus indidriver)
install(TARGETS indi_moonlite_focus RUNTIME DESTINATION bin)

# ############### Moonlite DRO Dual Focuser ################
SET(moonlitedro_SRC
    moonlite_dro.cpp)

add_executable(indi_moonlitedro_focus ${moonlitedro_SRC})
target_link_libraries(indi_moonlitedro_focus indidriver)
install(TARGETS indi_moonlitedro_focus RUNTIME DESTINATION bin)

# ############### MyFocuserPro2 Focuser ################
SET(myfocuserpro2_SRC
    myfocuserpro2.cpp)

add_executable(indi_myfocuserpro2_focus ${myfocuserpro2_SRC})
target_link_libraries(indi_myfocuserpro2_focus indidriver)
install(TARGETS indi_myfocuserpro2_focus RUNTIME DESTINATION bin)

# ############### OnFocus Focuser ################
SET(onfocus_SRC
    onfocus.cpp)

add_executable(indi_onfocus_focus ${onfocus_SRC})
target_link_libraries(indi_onfocus_focus indidriver)
install(TARGETS indi_onfocus_focus RUNTIME DESTINATION bin)

# ############### TeenAstro Focuser ################
SET(teenastro_focus_SRC
    teenastro.cpp)

add_executable(indi_teenastro_focus ${teenastro_focus_SRC})
target_link_libraries(indi_teenastro_focus indidriver)
install(TARGETS indi_teenastro_focus RUNTIME DESTINATION bin)

# ############### Sesto Senso Focuser ################
SET(sesto_SRC
    sestosenso.cpp)

add_executable(indi_sestosenso_focus ${sesto_SRC})
target_link_libraries(indi_sestosenso_focus indidriver)
install(TARGETS indi_sestosenso_focus RUNTIME DESTINATION bin)

# ############### Sesto Senso 2 Focuser ################
SET(sesto2_SRC
    sestosenso2.cpp
    primalucacommandset.cpp
)

add_executable(indi_sestosenso2_focus ${sesto2_SRC})
target_link_libraries(indi_sestosenso2_focus indidriver ${JSONLIB})
install(TARGETS indi_sestosenso2_focus RUNTIME DESTINATION bin)

# ############### Esatto Focuser ################
SET(esatto_SRC
    esatto.cpp
    primalucacommandset.cpp
)

add_executable(indi_esatto_focus ${esatto_SRC})
target_link_libraries(indi_esatto_focus indidriver ${JSONLIB})
install(TARGETS indi_esatto_focus RUNTIME DESTINATION bin)

# ############### Esatto with Arco Focuser ################
SET(esarc_SRC
    esattoarco.cpp
    primalucacommandset.cpp
)

add_executable(indi_esattoarco_focus ${esarc_SRC})
target_link_libraries(indi_esattoarco_focus indidriver ${JSONLIB})
install(TARGETS indi_esattoarco_focus RUNTIME DESTINATION bin)

# ############### Televue FocusMaster ################
# SET(focusmaster_SRC
# focusmaster.cpp)

# add_executable(indi_focusmaster_focus ${focusmaster_SRC})
# target_link_libraries(indi_focusmaster_focus indidriver)
# install(TARGETS indi_focusmaster_focus RUNTIME DESTINATION bin)

# ############### RainbowAstro RSF Focuser ################
SET(RSF_SRC
    rainbowRSF.cpp)

add_executable(indi_rainbowrsf_focus ${RSF_SRC})
target_link_libraries(indi_rainbowrsf_focus indidriver)
install(TARGETS indi_rainbowrsf_focus RUNTIME DESTINATION bin)

# ############### Dream Focuser ################
SET(dreamfocuser_SRC
    dreamfocuser.cpp)

add_executable(indi_dreamfocuser_focus ${dreamfocuser_SRC})
target_link_libraries(indi_dreamfocuser_focus indidriver)
install(TARGETS indi_dreamfocuser_focus RUNTIME DESTINATION bin)

# ########## Lakeside ###########
set(indilakeside_SRCS lakeside.cpp)

add_executable(indi_lakeside_focus ${indilakeside_SRCS})

IF(NOT "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" AND NOT "${CMAKE_CXX_COMPILER_ID}" STREQUAL "AppleClang")
    set_target_properties(indi_lakeside_focus PROPERTIES COMPILE_FLAGS "-Wno-format-overflow")
ENDIF()

target_link_libraries(indi_lakeside_focus indidriver)
install(TARGETS indi_lakeside_focus RUNTIME DESTINATION bin)

# ############### Pegasus DMFC Focuser ################
SET(pegasus_SRC
    dmfc.cpp)

add_executable(indi_dmfc_focus ${pegasus_SRC})
target_link_libraries(indi_dmfc_focus indidriver)
install(TARGETS indi_dmfc_focus RUNTIME DESTINATION bin)

# ############### Pegasus FocusCube Focuser ################
SET(pegasusfocuscube_SRC
    pegasus_focuscube.cpp)

add_executable(indi_pegasus_focuscube ${pegasusfocuscube_SRC})
target_link_libraries(indi_pegasus_focuscube indidriver)
install(TARGETS indi_pegasus_focuscube RUNTIME DESTINATION bin)

# ############### Pegasus FocusCube3 Focuser ################
SET(pegasusfocuscube3_SRC
    pegasus_focuscube3.cpp)

add_executable(indi_pegasus_focuscube3 ${pegasusfocuscube3_SRC})
target_link_libraries(indi_pegasus_focuscube3 indidriver)
install(TARGETS indi_pegasus_focuscube3 RUNTIME DESTINATION bin)

# ############### Pegasus ProdigyMF Focuser ################
SET(pegasusprodigyMF_SRC
    pegasus_prodigyMF.cpp)

add_executable(indi_pegasus_prodigyMF ${pegasusprodigyMF_SRC})
target_link_libraries(indi_pegasus_prodigyMF indidriver)
install(TARGETS indi_pegasus_prodigyMF RUNTIME DESTINATION bin)

# ############### Pegasus ScopsOAG Focuser ################
SET(pegasusScopsoag_SRC
    pegasus_scopsoag.cpp)

add_executable(indi_pegasus_scopsoag ${pegasusScopsoag_SRC})
target_link_libraries(indi_pegasus_scopsoag indidriver)
install(TARGETS indi_pegasus_scopsoag RUNTIME DESTINATION bin)

# ################# USB Focus V3 ##################
SET(usbfocusv3_SRC
    usbfocusv3.cpp)

add_executable(indi_usbfocusv3_focus ${usbfocusv3_SRC})
target_link_libraries(indi_usbfocusv3_focus indidriver)
install(TARGETS indi_usbfocusv3_focus RUNTIME DESTINATION bin)

# ############### Microtouch Focuser ################
SET(microtouch_SRC
    microtouch.cpp)

add_executable(indi_microtouch_focus ${microtouch_SRC})
target_link_libraries(indi_microtouch_focus indidriver)
install(TARGETS indi_microtouch_focus RUNTIME DESTINATION bin)

# ############### Baader SteelDrive II Focuser ################
SET(steeldrive2_SRC
    steeldrive2.cpp)

add_executable(indi_steeldrive2_focus ${steeldrive2_SRC})
target_link_libraries(indi_steeldrive2_focus indidriver)
install(TARGETS indi_steeldrive2_focus RUNTIME DESTINATION bin)

# ############### Baader SteelDrive Focuser ################
SET(steeldrive_SRC
    steeldrive.cpp)

add_executable(indi_steeldrive_focus ${steeldrive_SRC})
target_link_libraries(indi_steeldrive_focus indidriver)
install(TARGETS indi_steeldrive_focus RUNTIME DESTINATION bin)

################ Alluna TCS2 Focuser ################

SET(allunatcs2_SRC
    alluna_tcs2.cpp)

add_executable(indi_alluna_tcs2 ${allunatcs2_SRC})
target_link_libraries(indi_alluna_tcs2 indidriver)
install(TARGETS indi_alluna_tcs2 RUNTIME DESTINATION bin)

# ############### FocusLynx Focuser ################
SET(focuslynx_SRC
    focuslynxbase.cpp
    focuslynx.cpp)

IF(UNITY_BUILD)
    ENABLE_UNITY_BUILD(focuslynx focuslynx_SRC 10 cpp)
ENDIF()

add_executable(indi_lynx_focus ${focuslynx_SRC})
target_link_libraries(indi_lynx_focus indidriver)
install(TARGETS indi_lynx_focus RUNTIME DESTINATION bin)

# ############### PerfectStar Focuser ################
SET(perfectstar_SRC
    perfectstar.cpp)

add_executable(indi_perfectstar_focus ${perfectstar_SRC})
target_link_libraries(indi_perfectstar_focus indidriver)
install(TARGETS indi_perfectstar_focus RUNTIME DESTINATION bin)

# ############### Starlight Instruments EFS ################
SET(siefs_SRC
    si_efs.cpp)

add_executable(indi_siefs_focus ${siefs_SRC})
target_link_libraries(indi_siefs_focus indidriver)
install(TARGETS indi_siefs_focus RUNTIME DESTINATION bin)

# ############### hitechfocus Focuser ################
SET(hitecastrodcfocuser_SRC
    hitecastrodcfocuser.cpp)

add_executable(indi_hitecastrodc_focus ${hitecastrodcfocuser_SRC})
target_link_libraries(indi_hitecastrodc_focus indidriver)
install(TARGETS indi_hitecastrodc_focus RUNTIME DESTINATION bin)

# ############### DeepSky Dad AF1 ################
SET(deepskydad_af1_SRC
    deepskydad_af1.cpp)

add_executable(indi_deepskydad_af1_focus ${deepskydad_af1_SRC})
target_link_libraries(indi_deepskydad_af1_focus indidriver)
install(TARGETS indi_deepskydad_af1_focus RUNTIME DESTINATION bin)

# ############### DeepSky Dad AF2 ################
SET(deepskydad_af2_SRC
    deepskydad_af2.cpp)

add_executable(indi_deepskydad_af2_focus ${deepskydad_af2_SRC})
target_link_libraries(indi_deepskydad_af2_focus indidriver)
install(TARGETS indi_deepskydad_af2_focus RUNTIME DESTINATION bin)

# ############### DeepSky Dad AF3 ################
SET(deepskydad_af3_SRC
    deepskydad_af3.cpp)

add_executable(indi_deepskydad_af3_focus ${deepskydad_af3_SRC})
target_link_libraries(indi_deepskydad_af3_focus indidriver)
install(TARGETS indi_deepskydad_af3_focus RUNTIME DESTINATION bin)

# ############### JMI Smart Focus Focuser ################
SET(smartfocus_SRC
    smartfocus.cpp)

add_executable(indi_smartfocus_focus ${smartfocus_SRC})
target_link_libraries(indi_smartfocus_focus indidriver)

=== libs/dsp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
project(dsp C)
if(CMAKE_VERSION VERSION_GREATER_EQUAL 3.31)
    cmake_policy(SET CMP0177 NEW)
endif()

add_library(${PROJECT_NAME} OBJECT "")

# Headers
list(APPEND ${PROJECT_NAME}_HEADERS
    dsp.h
    fits_extensions.h
    fits.h
    sdfits.h
    fitsidi.h
)

list(APPEND ${PROJECT_NAME}_PRIVATE_HEADERS
)

# Sources
list(APPEND ${PROJECT_NAME}_SOURCES
    fits.c
    file.c
    buffer.c
    convert.c
    fft.c
    filters.c
    signals.c
    convolution.c
    stats.c
    stream.c
)

# Setup Target
target_sources(${PROJECT_NAME}
    PUBLIC
    ${${PROJECT_NAME}_HEADERS}
    PRIVATE
    ${${PROJECT_NAME}_SOURCES}
    ${${PROJECT_NAME}_PRIVATE_HEADERS}
)

target_include_directories(${PROJECT_NAME}
    PUBLIC .
)

install(FILES
    ${${PROJECT_NAME}_HEADERS}
    DESTINATION
    ${INCLUDE_INSTALL_DIR}/libindi
    COMPONENT Devel
)

=== libs/indiclientqt/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)
project(indiclientqt CXX)

set(QT_ANDROID "" CACHE STRING "Qt Android path")

if(ANDROID)
    set(Qt5Core_DIR "${QT_ANDROID}/lib/cmake/Qt5Core")
    include(${QT_ANDROID}/lib/cmake/Qt5/Qt5Config.cmake)
    include(${QT_ANDROID}/lib/cmake/Qt5Core/Qt5CoreConfig.cmake)
    include(${QT_ANDROID}/lib/cmake/Qt5Network/Qt5NetworkConfig.cmake)

    if(NOT CFITSIO_DIR)
        message(FATAL_ERROR CFITSIO_DIR must be set)
    else()
        set(CFITSIO_INCLUDE_DIR ${CFITSIO_DIR})
        set(CFITSIO_LIBRARIES ${CFITSIO_DIR}/libcfitsio.a)
    endif()
else()
    find_package(Qt5Core REQUIRED)
    find_package(Qt5Network REQUIRED)
    find_package(ZLIB REQUIRED)
    find_package(CFITSIO REQUIRED)
endif()

list(APPEND ${PROJECT_NAME}_LIBS
    indicore
    indidevice
    indiabstractclient
    Qt5::Network
    ${ZLIB_LIBRARY}
)

# Sources
list(APPEND ${PROJECT_NAME}_SOURCES
    baseclientqt.cpp
)

# Headers
list(APPEND ${PROJECT_NAME}_HEADERS
    baseclientqt.h
)

# Private Headers
list(APPEND ${PROJECT_NAME}_PRIVATE_HEADERS
    baseclientqt_p.h
)

# Build Object Library
add_library(${PROJECT_NAME}_OBJECT OBJECT)
set_property(TARGET ${PROJECT_NAME}_OBJECT PROPERTY POSITION_INDEPENDENT_CODE 1)

target_include_directories(${PROJECT_NAME}_OBJECT
    PUBLIC .
)

target_sources(${PROJECT_NAME}_OBJECT
    PUBLIC
    ${${PROJECT_NAME}_HEADERS}
    PRIVATE
    ${${PROJECT_NAME}_SOURCES}
    ${${PROJECT_NAME}_PRIVATE_HEADERS}
)

target_link_libraries(${PROJECT_NAME}_OBJECT ${${PROJECT_NAME}_LIBS})

install(FILES
    ${${PROJECT_NAME}_HEADERS}
    DESTINATION
    ${INCLUDE_INSTALL_DIR}/libindi
    COMPONENT Devel
)

# Build Static Library
if(INDI_BUILD_STATIC)
    add_library(${PROJECT_NAME}static STATIC)

    target_link_libraries(${PROJECT_NAME}static ${PROJECT_NAME}_OBJECT ${${PROJECT_NAME}_LIBS})
    target_include_directories(${PROJECT_NAME}static
        PUBLIC .
    )

    set_target_properties(${PROJECT_NAME}static PROPERTIES
        VERSION ${CMAKE_INDI_VERSION_STRING}
        SOVERSION ${INDI_SOVERSION}
        OUTPUT_NAME ${PROJECT_NAME} # this same name like shared library - backwards compatibility
    )

    install(TARGETS ${PROJECT_NAME}static
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
endif()

# Build Shared Library
if(INDI_BUILD_SHARED)
    add_library(${PROJECT_NAME} SHARED)

    target_link_libraries(${PROJECT_NAME} ${PROJECT_NAME}_OBJECT ${${PROJECT_NAME}_LIBS})
    target_include_directories(${PROJECT_NAME}
        PUBLIC .
    )

    set_target_properties(${PROJECT_NAME} PROPERTIES
        VERSION ${CMAKE_INDI_VERSION_STRING}
        SOVERSION ${INDI_SOVERSION}
        OUTPUT_NAME ${PROJECT_NAME}
    )

    install(TARGETS ${PROJECT_NAME}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )
endif()

=== test/alignment/CMakeLists.txt ===
INCLUDE_DIRECTORIES( ${INDI_INCLUDE_DIR} )

ADD_EXECUTABLE(test_alignment
    test_alignment.cpp
)

TARGET_LINK_LIBRARIES(test_alignment
    AlignmentDriver
    indidriver
    ${GTEST_BOTH_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT}
)

ADD_TEST(test-alignment test_alignment)

=== debian/changelog ===
libindi (2.1.6) jammy; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Thu, 2 Oct 2025 10:00:00 +0300

libindi (2.1.5) jammy; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Sun, 10 Aug 2025 10:00:00 +0300

libindi (2.1.4) jammy; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Sun, 1 Jun 2025 10:00:00 +0300

libindi (2.1.3) focal; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Tue, 1 Apr 2025 10:00:00 +0300

libindi (2.1.2) focal; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Sat, 1 Feb 2025 10:00:00 +0300

libindi (2.1.1) focal; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Mon, 2 Dec 2024 10:00:00 +0300

libindi (2.1.0) focal; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Tue, 1 Oct 2024 10:00:00 +0300

libindi (2.0.9) focal; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Fri, 2 Aug 2024 10:00:00 +0300

libindi (2.0.8) focal; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Sat, 1 Jun 2024 10:00:00 +0300

libindi (2.0.7) focal; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Mon, 1 Apr 2024 10:00:00 +0300

libindi (2.0.6) focal; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Thu, 1 Feb 2024 10:00:00 +0300

libindi (2.0.5) focal; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Fri, 1 Dec 2023 10:00:00 +0300

libindi (2.0.4) focal; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Sun, 1 Oct 2023 10:00:00 +0300

libindi (2.0.3) focal; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Tue, 1 Aug 2023 10:00:00 +0300

libindi (2.0.2) focal; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Sun, 9 Apr 2023 10:00:00 +0300

libindi (2.0.1) focal; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Sat, 4 Feb 2023 10:00:00 +0300

libindi (2.0.0) focal; urgency=medium

  * Major release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Sun, 8 Jan 2023 10:00:00 +0300

libindi (1.9.9) focal; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Sat, 15 Oct 2022 09:00:00 +0300

libindi (1.9.8) focal; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Sun, 31 Jul 2022 15:00:00 +0300

libindi (1.9.7) focal; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Sun, 29 May 2022 15:00:00 +0300

libindi (1.9.6) focal; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Mon, 21 Mar 2022 15:00:00 +0300

libindi (1.9.5) focal; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Tue, 25 Jan 2022 15:00:00 +0300

libindi (1.9.4) focal; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Fri, 31 Dec 2021 15:00:00 +0300

libindi (1.9.3) focal; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Wed, 15 Sep 2021 15:00:00 +0300

libindi (1.9.2) focal; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Tue, 6 Jul 2021 15:00:00 +0300

libindi (1.9.1) focal; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Sun, 25 Apr 2021 15:00:00 +0300

libindi (1.9.0) focal; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Thu, 04 Mar 2021 15:00:00 +0300

libindi (1.8.9) focal; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Tue, 12 Jan 2020 15:00:00 +0300

libindi (1.8.8) focal; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Wed, 02 Dec 2020 15:00:00 +0300

libindi (1.8.7) focal; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Sat, 22 Aug 2020 15:00:00 +0300

libindi (1.8.6) bionic; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Tue, 28 Apr 2020 19:00:00 +0300

libindi (1.8.5) bionic; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Sat, 07 Mar 2020 19:00:00 +0300

libindi (1.8.4) bionic; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Sat, 18 Jan 2020 19:00:00 +0300

libindi (1.8.3) bionic; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Wed, 1 Jan 2020 19:00:00 +0300

libindi (1.8.2) bionic; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Tue, 13 Oct 2019 19:00:00 +0300

libindi (1.8.1) bionic; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Tue, 13 Aug 2019 19:00:00 +0300

libindi (1.8.0) bionic; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Sat, 27 Jul 2019 19:00:00 +0300

libindi (1.7.9) bionic; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Sat, 22 Jun 2019 19:00:00 +0300

libindi (1.7.8) bionic; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Sat, 11 May 2019 13:00:00 +0300

libindi (1.7.7) bionic; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Sun, 14 Feb 2019 19:36:00 +0300

libindi (1.7.6) bionic; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Sat, 01 Dec 2018 01:30:00 +0300

libindi (1.7.5) bionic; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Thu, 27 Sep 2018 09:30:00 +0300

libindi (1.7.4) bionic; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Thu, 19 Jul 2018 09:30:00 +0300

libindi (1.7.3) bionic; urgency=medium

  * Minor release.

 -- Jasem Mutlaq <mutlaqja@ikarustech.com>  Sun, 20 May 2018 09:30:00 +0300



=== debian/control ===
Source: libindi
Section: misc
Priority: optional
Maintainer: Jasem Mutlaq <mutlaqja@ikarustech.com>
Build-Depends: debhelper (>= 9),
               cdbs,
               cmake (>= 3.0),
               libcfitsio-dev,
               libnova-dev,
               libusb-1.0-0-dev,
               zlib1g-dev,
               libjpeg-dev,
               libgsl-dev,
               libcurl4-gnutls-dev,
               libtheora-dev,
               libogg-dev,
               libfftw3-dev,
               libev-dev,
               librtlsdr-dev,
               libxisf-dev,
Standards-Version: 3.9.5
Homepage: http://www.indilib.org/
Vcs-Git: git://github.com/indilib/indi.git

Package: libindi1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libindi-data (>= ${source:Version}), indi-bin (>= ${source:Version})
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
conflicts: libindi0, libindi-plugins, libindialignmentdriver1, libindidriver1
replaces: libindi0, libindi-plugins, libindialignmentdriver1, libindidriver1
Description: Instrument-Neutral Device Interface library -- shared library
 INDI (Instrument-Neutral Device Interface) is a distributed XML-based
 control protocol designed to operate astronomical instrumentation.
 INDI is small, flexible, easy to parse, scalable, and stateless.
 It supports common DCS functions such as remote control, data acquisition,
 monitoring, and a lot more.
 .
 This package contains the shared library.

Package: libindi-dev
Section: libdevel
Architecture: any
Depends: libindi1 (= ${binary:Version}), ${misc:Depends}, libusb-1.0-0-dev
Description: Instrument-Neutral Device Interface library -- development files
 INDI (Instrument-Neutral Device Interface) is a distributed XML-based
 control protocol designed to operate astronomical instrumentation.
 INDI is small, flexible, easy to parse, scalable, and stateless.
 It supports common DCS functions such as remote control, data acquisition,
 monitoring, and a lot more.
 .
 This package contains development headers and libraries for the INDI library.

Package: libindi-data
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Instrument-Neutral Device Interface library -- shared data
 INDI (Instrument-Neutral Device Interface) is a distributed XML-based
 control protocol designed to operate astronomical instrumentation.
 INDI is small, flexible, easy to parse, scalable, and stateless.
 It supports common DCS functions such as remote control, data acquisition,
 monitoring, and a lot more.
 .
 This package contains the data files for the INDI library.

Package: indi-bin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libindi-data (>= ${source:Version})
conflicts: indi-astrolink4, indi-astromechfoc, indi-dreamfocuser, indi-spectracyber
replaces: indi-astrolink4, indi-astromechfoc, indi-dreamfocuser, indi-spectracyber
Description: INDI server, drivers and tools
 INDI (Instrument-Neutral Device Interface) is a distributed XML-based
 control protocol designed to operate astronomical instrumentation.
 INDI is small, flexible, easy to parse, scalable, and stateless.
 It supports common DCS functions such as remote control, data acquisition,
 monitoring, and a lot more.
 .
 This package contains the INDI server, the drivers for the supported
 astronomical instrumentation, and other INDI tools.

Package: indi-dbg
Priority: extra
Section: debug
Architecture: any
Depends: libindi1 (= ${binary:Version}), ${misc:Depends}
Suggests: indi-bin (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
conflicts: indi-astrolink4-dbg, indi-astromechfoc-dbg, indi-dreamfocuser-dbg, indi-spectracyber-dbg
replaces: indi-astrolink4-dbg, indi-astromechfoc-dbg, indi-dreamfocuser-dbg, indi-spectracyber-dbg
Description: Instrument-Neutral Device Interface library -- debug symbols
 INDI (Instrument-Neutral Device Interface) is a distributed XML-based
 control protocol designed to operate astronomical instrumentation.
 INDI is small, flexible, easy to parse, scalable, and stateless.
 It supports common DCS functions such as remote control, data acquisition,
 monitoring, and a lot more.
 .
 This package contains the debug symbols for the INDI library and all the
 utilities, useful to investigate problems in INDI.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk

# Enable specific hardening flags but avoid the most performance-impacting ones
export DEB_BUILD_MAINT_OPTIONS = hardening=+format,+fortify,+stackprotector,+relro,-pie,-bindnow

# Add some defensive flags without significant performance impact
export DEB_CFLAGS_MAINT_APPEND = -Wall -fno-strict-aliasing
export DEB_CXXFLAGS_MAINT_APPEND = -Wall -fno-strict-aliasing

# Ensure proper RPATH handling to find libraries
DEB_CMAKE_EXTRA_FLAGS += -DCMAKE_INSTALL_RPATH_USE_LINK_PATH=ON

# Build with symbols for better debugging
DEB_CMAKE_EXTRA_FLAGS += -DCMAKE_BUILD_TYPE=RelWithDebInfo
